WSAPROTOCOLCHAIN struc
	ChainLen dd ?       	;/* the length of the chain,  */
                            ;/* length = 0 means layered protocol, */
                            ;/* length = 1 means base protocol,
                            ;/* length > 1 means protocol chain */
	ChainEntries dd MAX_PROTOCOL_CHAIN dup(?)
                            ;/* a list of dwCatalogEntryIds */
WSAPROTOCOLCHAIN ends


WSAPROTOCOL_INFO struc
	dwServiceFlags1 dd ?
	dwServiceFlags2 dd ?
	dwServiceFlags3 dd ?
	dwServiceFlags4 dd ?
	dwProviderFlags dd ?
    ProviderId GUID <>
	dwCatalogEntryId dd ?
	ProtocolChain WSAPROTOCOLCHAIN <>
	iVersion dd ?
	iAddressFamily dd ?
	iMaxSockAddr dd ?
	iMinSockAddr dd ?
	iSocketType dd ?
	iProtocol dd ?
	iProtocolMaxOffset dd ?
	iNetworkByteOrder dd ?
	iSecurityScheme dd ?
	dwMessageSize dd ?
	dwProviderReserved dd ?
	szProtocol db WSAPROTOCOL_LEN+1 dup(?)
WSAPROTOCOL_INFO ends 
comment $         .const.
      .
  <    !<,   >  !>$
CONSTANT MACRO string:VARARG
.const
	string
.code
ENDM
comment $         .data.
      .
  <    !<,   >  !>$
STATIC MACRO string:VARARG
.data
	string
.code
ENDM
comment $       
   .data?.
      .
  <    !<,   >  !>$
RESERV MACRO string:VARARG
.data?
	string
.code
ENDM